package tp4_correction.q3;

public class MonitoredBuffer {

	private String buffer = "";
	private boolean full = false;
	final Object LOCK = new Object();

	public void put(String word) {

		synchronized (LOCK) {
			try {
				if (full)
					LOCK.wait();

				buffer = buffer + word;

				if (buffer.length() > 40) {
					full = true;
					LOCK.notify();
				}
			} catch (InterruptedException e) {
			}

		}
	}

	public String get() {
		String tmp = "";
		synchronized (LOCK) {
			try {

				if (!full)
					LOCK.wait();

				tmp = buffer;
				buffer = "";
				full = false;
				LOCK.notify();
			} catch (InterruptedException e) {
			}

			return tmp;
		}
	}

}
