package tp4_correction.exam;

public class JobSylvieEtBruno implements Runnable {

	private Compte compte = new Compte();

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		JobSylvieEtBruno tache = new JobSylvieEtBruno();
		Thread t1 = new Thread(tache);
		t1.setName("Bruno");
		Thread t2 = new Thread(tache);
		t2.setName("Sylvie");
		t1.start();
		t2.start();
	}

	@Override
	public void run() {
		for (int x = 0; x < 10; x++) {
			effectuerRetrait(10);
			if (compte.getSolde() < 0) {
				System.out.println("Dcouvert !");
			}
		}
	}

	private void effectuerRetrait(int montant) {
		String nom = Thread.currentThread().getName();

		synchronized (compte) {
			if (compte.getSolde() >= montant) {
				System.out.println(nom + " va retirer");

				try {
					System.out.println(nom + " va dormir");
					Thread.sleep(500);
				} catch (InterruptedException e) {

				}
				System.out.println(nom + " se reveille");
				compte.retirer(montant);
				System.out.println(nom + " retrait fait");

			} else {
				System.out.println(nom + " pas assez d'argent");
			}
		}
	} // fin mthode effectuerRetrait
} // fin de la classe
